#! /usr/bin/python
# -*- python -*-

import string
from httplib import HTTP
from perfmod import *

def payment():
    
    # Imagine that Sally wants to buy a CD. She calls seller-order.cgi
    # to order her CD.

    postdata = "buyer=mc-own-account&seller=foobar&amount=75&currency=SEK"

    url = "/seller-order.cgi?%s" % (postdata)

    h = httpsend("localhost", 4000, "GET", url, "")

    errcode, errmsg, headers = h.getreply()
    if errcode == 200:
	response = string.strip(h.getfile().read())
    else:
	print "Error in sending order:", errcode, errmsg

    # print "Sent order."

    # Sally needs to send her approval to the IPP, so she contacts the
    # Internet Payment Provider with the tnxid she got back, "foo".

    url = "/ipp-approval.cgi?tnxid=foo"

    h = httpsend("localhost", 8000, "GET", url, "")

    errcode, errmsg, headers = h.getreply()
    if errcode == 200:
	response = string.strip(h.getfile().read())

    #print "Got approval form."
    
    # Sally now needs to send an OK to the IPP to let them know the
    # transaction is legit.

    url = "/ipp-deal.cgi?tnxid=foo&choice=OK"

    h = httpsend("localhost", 8000, "GET", url, "")

    errcode, errmsg, headers = h.getreply()
    if errcode == 200:
	response = string.strip(h.getfile().read())

    #print "Approved transaction."
    
    # The transaction is completed.

# Main program

for i in range(0, 999):
    payment()
